-- FallBlame by Indev for Sunflower's Garden
-- Replicate HP MOD's fall event, except at all time with a few custom additions
local cv_fb_debug = CV_RegisterVar({
    name = "fb_debug",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
})

local FALL_BLAME_TIME = 2*TICRATE

local function generateHFForPlayer(p)
	if p and p.valid and p.mo and p.mo.valid then
		return {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
	else
		return {{}, {}}
	end
end

local function dprint(str)
    if not cv_fb_debug.value then return end

    print("[fb_debug] "..str)
end

local function setFallBlame(victim, attacker)
    dprint("Set "..attacker.name.." as fallblame for "..victim.name)

    victim.fallblame_timer = FALL_BLAME_TIME
    victim.fallblame = attacker
end

local function clearFallBlame(victim)
    dprint("Clear fallblame for "..victim.name)

    victim.fallblame_timer = nil
    victim.fallblame = nil
end

local function sendHitfeedEvent(victim, attacker)
    if hpmod and hpmod.running then return end

    if attacker and not attacker.valid then
        attacker = nil
    else
        if attacker and victim ~= attacker then
            K_PlayHitEmSound(attacker.mo)
        else
            -- You played yourself idiot
            attacker = nil
        end
    end

    local vname = victim and victim.name or "[REDACTED]"
    local aname = attacker and attacker.name or "[REDACTED]"

    dprint(vname.." fall off the map because of "..aname)

    if hitfeed then
        if not HF_animIcon["K_HMFAL"] then
            --print("no fall icon registered registering")
            HF_animIcon["K_HMFAL"] = {4, 6}
            --print("registered fall icon")
        end

        HF_SendHitMessage(generateHFForPlayer(attacker), generateHFForPlayer(victim), "K_HMFAL")
    end

    clearFallBlame(victim)
end

addHook("MobjCollide", function(pmo, mo)
    if not mo.player then return end

    if pmo.z > (mo.z + mo.height) or mo.z > (pmo.z + pmo.height) then return end
    if pmo.player.powers[pw_flashing] or mo.player.powers[pw_flashing] then return end

    setFallBlame(pmo.player, mo.player)
    setFallBlame(mo.player, pmo.player)
end, MT_PLAYER)

addHook("PlayerSpin", function(player, _, inflictor)
    if inflictor and inflictor.player then
        setFallBlame(player, inflictor.player)
    end
end)

-- Rare cases of player being squished in air
addHook("PlayerSquish", function(player, _, inflictor)
    if inflictor and inflictor.player then
        setFallBlame(player, inflictor.player)
    end
end)

addHook("PlayerExplode", function(player, _, inflictor)
    if inflictor and inflictor.player then
        setFallBlame(player, inflictor.player)
    end
end)

addHook("MobjDeath", function(pmo, mo, pmo2)
    if mo and mo.type == MT_SINK then return end
    if pmo.player.pflags & PF_TIMEOVER then return end
	if (FZeroKart and FZeroKart.Active.value) then return end

    local player = pmo.player

    sendHitfeedEvent(player, player.fallblame)
end, MT_PLAYER)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.fallblame_timer
            and player.mo
            and player.mo.valid
            and P_IsObjectOnGround(player.mo)
            and not player.kartstuff[k_spinouttimer]
            and not player.kartstuff[k_wipeoutslow] then

            player.fallblame_timer = $ - 1
        end

        if player.fallblame_timer == 0 then
            clearFallBlame(player)
        end
    end
end)
