-- Mine behaviour changes by Indev and RetroStation
-- tweak thoughts by AnimeSonic / Sunflower#1739
-- Mines will no longer arm when someone is in growth or invincible
-- Mines will no longer arm when someone is in i.frames
-- Former puts a stop on people 1 lap behind ruining your mines
-- Latter stop the nasty bahaviour of people putting mines after teleporters
--
-- v2: Due to complaints they will still explode when going through them now

--Dinomial Edits:
-- Removed Mobj Thinker for MT_MINERANGE
-- All movement is handled in Single Hook for MT_SSMINE_SHIELD rather than each indiv MineRange Object Calculating their own position
-- Hopefully this helps with performance

freeslot(
	"SPR_MNWR",
	"MT_MINERANGE",
	"S_MINERANGE"
)

states[S_MINERANGE] = {SPR_MNWR, FF_FULLBRIGHT|A, 2, nil, 0, 0, S_NULL}
mobjinfo[MT_MINERANGE] = {
	spawnstate = S_MINERANGE,
	spawnhealth = 1000,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_DONTENCOREMAP|MF_NOCLIP|MF_SCENERY
}

local function cSpd(ang, spd, mo)
	if mo == nil then mo = {scale=FRACUNIT} end
	spd = FixedMul(spd, mo.scale)
	return FixedMul( cos(ang), spd ), FixedMul( sin(ang), spd )
	--returns x and y of calc
end

local function ShouldTriggerMine(p)
	local pks = p.kartstuff
	
	return not ((pks[k_invincibilitytimer] > 0) or (pks[k_growshrinktimer] > 0) or (pks[k_squishedtimer] > 0) or (HugeQuest and p.hugequest.huge > 0) or (pks[k_hyudorotimer] > 0) or (p.powers[pw_flashing] > 0) or (G_BattleGametype() and pks[k_bumper] <= 0 and pks[k_comebacktimer]))
end

function A_GrenadeRing(actor)

    local explodedist = FixedMul(actor.info.painchance, mapobjectscale)
	
	-- RetroStation: HugeQuest interop
	if actor.scale > mapobjectscale then
		explodedist = FixedMul($, FixedDiv(actor.scale, mapobjectscale))
	end
	
    if actor.flags2 & MF2_DEBRIS then
        return
    end

    if actor.state == S_SSMINE_DEPLOY8 then
        explodedist = (3*explodedist)/2
		
		-- RetroStation: Spawn trigger range indicator
		-- Dinomial: Did a shitton of changes to the range indicator
		if actor.MNorbit == nil then
			actor.MNorbit = {}
			for i = 1, 8 do
				local e = P_SpawnMobj(actor.x, actor.y, actor.z, MT_MINERANGE)
				e.colorized = true
				e.scale = (3*mapobjectscale)/4
				e.color = actor.color
				table.insert(actor.MNorbit, e)
			end
		end
    end

    if leveltime % 35 == 0 then
        S_StartSound(actor, actor.info.activesound)
    end

    for player in players.iterate do
        if not player.spectator then
            if R_PointToDist2(player.mo.x, player.mo.y, actor.x, actor.y) < explodedist
                and abs(player.mo.z - actor.z) < explodedist
                and ShouldTriggerMine(player) then

                actor.state = actor.info.deathstate
                return
            end
        end
    end
end
-- Dinomial: Controls the Range Indicator
addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	if not mo.MNorbit then return end
	
	local explodedist = FixedMul(mo.info.painchance, mapobjectscale)
	
	if mo.scale > mapobjectscale then
		explodedist = FixedMul($, FixedDiv(mo.scale, mapobjectscale))
	end

	if mo.state == S_SSMINE_DEPLOY8 then
		explodedist = (3*explodedist)/2
	end
	
	for i = 1, 8 do
		local e = mo.MNorbit[i]	
		e.color = leveltime%7 > 3 and SKINCOLOR_RED or mo.color
		local rad = FixedMul(32*FRACUNIT, FixedMul(FixedDiv(explodedist, FixedMul(32*FRACUNIT, mapobjectscale)), mapobjectscale))
		local thisAng = (leveltime*(ANG2*3)) + (ANGLE_45 * i)

		local x,y = cSpd(thisAng, rad, mo)
		P_MoveOrigin(e, mo.x+x, mo.y+y, mo.z)
		e.tics = $ + 1
	end
end, MT_SSMINE_SHIELD)